/*********************************************************************/
/* tclparse V2.00 from 14.March 1997                                 */
/* Copyright 1996/97 Stephan Weiss, Heiko Grossmann                  */
/*                   University of Stuttgart, Germany                */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/

#ifndef _FILE_H_
#define _FILE_H_


#include "const.h"
#include "stack.h"
#include "handler.h"
#include <fstream.h>


class CInputFile
{
protected:

  char buffer[ 2000 ];

  struct {
    CTclStack saveStack;
    int cursorx, cursory;
    int errorx, errory;
    int braceFlag;
    int scanFlag;
    streampos saveErrorOffset[ 4 ];
    streampos offset;
  } save;

  ifstream file;

  streampos errorOffset[ 4 ];
  int errorLine[ 4 ];

  char *name;
  int size;

public:

  struct {
    char last[ bufferSize ];
    char actual[ bufferSize ];
    char next[ bufferSize ];
    char lastID[ bufferSize ];
    char actualID[ bufferSize ];
    char nextID[ bufferSize ];
  } atom, symbol;

  struct {
    char last[ bufferSize ];
    char actual[ bufferSize ];
    char lastID[ bufferSize ];
    char actualID[ bufferSize ];
  } word, unit;

  struct {
    int x, y;
  } cursor, error;

  int braceFlag;
  int scanFlag;

  CTclStack stack;
  CHandler handler;

  CInputFile( );
  CInputFile( char *fileName );
  ~CInputFile( void );

  void SetErrorOffset( void );
  streampos GetErrorOffset( void );

  char *Buffer( void );
  int Open( void );
  int Open( char *fileName );
  void CopyToBuffer( char *string );
  void Close( void );
  char *GetChar( void );
  char *GetLine( void );
  int Eof( void );
  char *Name( void );
  void Seek( streampos offset );
  void SetName( char *fileName );
  int Size( void );
  streampos Tell( void );

  void EnableBraceFlag( void );
  void EnableScanFlag( void );
  void DisableBraceFlag( void );
  void DisableScanFlag( void );

  void Save( void );
  void Restore( void );

  void DumpStacks( void );
};


extern CInputFile *actualFile;


#endif



