/*********************************************************************/
/* tclparse V2.00 from 14.March 1997                                 */
/* Copyright 1996/97 Stephan Weiss, Heiko Grossmann                  */
/*                   University of Stuttgart, Germany                */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/

#ifndef _STACK_H_
#define _STACK_H_


enum stackType { parens, braces, quotes, brackets, procedures, commands, normal };


class CStack
{
protected:

  /* Diese Struktur stellt ein Element auf dem Stack dar */
  struct SElement {
    char *content;
    SElement *prev;
    SElement *next;
  };

  /* Der Zeiger auf die Wurzel des Stacks */
  SElement *root;

  SElement *internalPtr;

public:

  CStack( void );
  ~CStack( void );

  char *First( void );
  char *Next( void );

  char *Concat( char* );
  int Contains( char* );
  char *Pop( void );
  void Push( char* );
  char *Top( void );

  CStack &operator=( CStack &stack );
};


class CTclStack
{
protected:

  /* Stack fuer oeffnende, runde Klammern */
  CStack parenStack;

  /* Stack fuer oeffnende, geschwungene Klammern */
  CStack braceStack;

  /* Stack fuer oeffnende Anfuehrungszeichen */
  CStack quoteStack;

  /* Stack fuer oeffnende, eckige Klammern */
  CStack bracketStack;

  /* Stack fuer Prozedurnamen */
  CStack procedureStack;

  /* Stack fuer Befehlsnamen */
  CStack commandStack;

  /* oeffentlicher Stack fuer Zeichenketten */
  CStack normalStack;

public:

  CTclStack( void );
  ~CTclStack( void );

  char *Concat( stackType, char* );
  int Contains( stackType, char* );
  char *Pop( stackType );
  void Push( stackType, char* );
  char *Top( stackType );

  CTclStack &operator=( CTclStack &stack );
};


#endif
